/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Represents the data transfer object (DTO) for FileSystemStorage options.
    /// </summary>
    [DataContract(Name = "FileSystemStorageOptionsDto")]
    public partial class FileSystemStorageOptionsDto : IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="FileSystemStorageOptionsDto" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected FileSystemStorageOptionsDto() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="FileSystemStorageOptionsDto" /> class.
        /// </summary>
        /// <param name="directory">The directory where the files are stored. (required).</param>
        public FileSystemStorageOptionsDto(string directory = default(string))
        {
            // to ensure "directory" is required (not null)
            if (directory == null)
            {
                throw new ArgumentNullException("directory is a required property for FileSystemStorageOptionsDto and cannot be null");
            }
            this.Directory = directory;
        }

        /// <summary>
        /// The directory where the files are stored.
        /// </summary>
        /// <value>The directory where the files are stored.</value>
        [DataMember(Name = "directory", IsRequired = true, EmitDefaultValue = true)]
        public string Directory { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class FileSystemStorageOptionsDto {\n");
            sb.Append("  Directory: ").Append(Directory).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
