/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// This class represents a maintenance with its significant properties, which is returned from the API.
    /// </summary>
    [DataContract(Name = "MaintenanceDto")]
    public partial class MaintenanceDto : IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="MaintenanceDto" /> class.
        /// </summary>
        /// <param name="displayName">Gets or sets the maintenance title..</param>
        /// <param name="href">Gets or sets the URL related to the maintenance..</param>
        /// <param name="type">Gets or sets the type of maintenance..</param>
        /// <param name="body">Gets or sets the description of the maintenance..</param>
        /// <param name="startsDate">Gets or sets the start date of the maintenance, if available..</param>
        /// <param name="endsDate">Gets or sets the end date of the maintenance, if available..</param>
        public MaintenanceDto(string displayName = default(string), string href = default(string), string type = default(string), string body = default(string), DateTime? startsDate = default(DateTime?), DateTime? endsDate = default(DateTime?))
        {
            this.DisplayName = displayName;
            this.Href = href;
            this.Type = type;
            this.Body = body;
            this.StartsDate = startsDate;
            this.EndsDate = endsDate;
        }

        /// <summary>
        /// Gets or sets the maintenance title.
        /// </summary>
        /// <value>Gets or sets the maintenance title.</value>
        [DataMember(Name = "displayName", EmitDefaultValue = false)]
        public string DisplayName { get; set; }

        /// <summary>
        /// Gets or sets the URL related to the maintenance.
        /// </summary>
        /// <value>Gets or sets the URL related to the maintenance.</value>
        [DataMember(Name = "href", EmitDefaultValue = false)]
        public string Href { get; set; }

        /// <summary>
        /// Gets or sets the type of maintenance.
        /// </summary>
        /// <value>Gets or sets the type of maintenance.</value>
        [DataMember(Name = "type", EmitDefaultValue = false)]
        public string Type { get; set; }

        /// <summary>
        /// Gets or sets the description of the maintenance.
        /// </summary>
        /// <value>Gets or sets the description of the maintenance.</value>
        [DataMember(Name = "body", EmitDefaultValue = false)]
        public string Body { get; set; }

        /// <summary>
        /// Gets or sets the start date of the maintenance, if available.
        /// </summary>
        /// <value>Gets or sets the start date of the maintenance, if available.</value>
        [DataMember(Name = "startsDate", EmitDefaultValue = true)]
        public DateTime? StartsDate { get; set; }

        /// <summary>
        /// Gets or sets the end date of the maintenance, if available.
        /// </summary>
        /// <value>Gets or sets the end date of the maintenance, if available.</value>
        [DataMember(Name = "endsDate", EmitDefaultValue = true)]
        public DateTime? EndsDate { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class MaintenanceDto {\n");
            sb.Append("  DisplayName: ").Append(DisplayName).Append("\n");
            sb.Append("  Href: ").Append(Href).Append("\n");
            sb.Append("  Type: ").Append(Type).Append("\n");
            sb.Append("  Body: ").Append(Body).Append("\n");
            sb.Append("  StartsDate: ").Append(StartsDate).Append("\n");
            sb.Append("  EndsDate: ").Append(EndsDate).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
