/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// MessageDto
    /// </summary>
    [DataContract(Name = "MessageDto")]
    public partial class MessageDto : IValidatableObject
    {

        /// <summary>
        /// Gets or Sets Type
        /// </summary>
        [DataMember(Name = "type", EmitDefaultValue = false)]
        public MessageType? Type { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="MessageDto" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected MessageDto() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="MessageDto" /> class.
        /// </summary>
        /// <param name="id">ID of the message. (required).</param>
        /// <param name="body">Message body in multiple languages as key-value pairs.   The key is the ISO 639-1 Alpha-2 two-letter language code, and the value is the message in that language..</param>
        /// <param name="type">type.</param>
        /// <param name="title">Title of the message..</param>
        /// <param name="href">URL related to the message..</param>
        /// <param name="startDate">Start date of the message (UTC)..</param>
        /// <param name="endDate">End date of the message (UTC)..</param>
        public MessageDto(string id = default(string), Dictionary<string, string> body = default(Dictionary<string, string>), MessageType? type = default(MessageType?), string title = default(string), string href = default(string), DateTime? startDate = default(DateTime?), DateTime? endDate = default(DateTime?))
        {
            // to ensure "id" is required (not null)
            if (id == null)
            {
                throw new ArgumentNullException("id is a required property for MessageDto and cannot be null");
            }
            this.Id = id;
            this.Body = body;
            this.Type = type;
            this.Title = title;
            this.Href = href;
            this.StartDate = startDate;
            this.EndDate = endDate;
        }

        /// <summary>
        /// ID of the message.
        /// </summary>
        /// <value>ID of the message.</value>
        [DataMember(Name = "id", IsRequired = true, EmitDefaultValue = true)]
        public string Id { get; set; }

        /// <summary>
        /// Message body in multiple languages as key-value pairs.   The key is the ISO 639-1 Alpha-2 two-letter language code, and the value is the message in that language.
        /// </summary>
        /// <value>Message body in multiple languages as key-value pairs.   The key is the ISO 639-1 Alpha-2 two-letter language code, and the value is the message in that language.</value>
        [DataMember(Name = "body", EmitDefaultValue = true)]
        public Dictionary<string, string> Body { get; set; }

        /// <summary>
        /// Title of the message.
        /// </summary>
        /// <value>Title of the message.</value>
        [DataMember(Name = "title", EmitDefaultValue = true)]
        public string Title { get; set; }

        /// <summary>
        /// URL related to the message.
        /// </summary>
        /// <value>URL related to the message.</value>
        [DataMember(Name = "href", EmitDefaultValue = true)]
        public string Href { get; set; }

        /// <summary>
        /// Start date of the message (UTC).
        /// </summary>
        /// <value>Start date of the message (UTC).</value>
        [DataMember(Name = "startDate", EmitDefaultValue = true)]
        public DateTime? StartDate { get; set; }

        /// <summary>
        /// End date of the message (UTC).
        /// </summary>
        /// <value>End date of the message (UTC).</value>
        [DataMember(Name = "endDate", EmitDefaultValue = true)]
        public DateTime? EndDate { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class MessageDto {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  Body: ").Append(Body).Append("\n");
            sb.Append("  Type: ").Append(Type).Append("\n");
            sb.Append("  Title: ").Append(Title).Append("\n");
            sb.Append("  Href: ").Append(Href).Append("\n");
            sb.Append("  StartDate: ").Append(StartDate).Append("\n");
            sb.Append("  EndDate: ").Append(EndDate).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
