/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Represents a data transfer object (DTO) for a project publication request.
    /// </summary>
    [DataContract(Name = "ProjectPublicationRequestDto")]
    public partial class ProjectPublicationRequestDto : IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ProjectPublicationRequestDto" /> class.
        /// </summary>
        /// <param name="id">Unique identifier for the project publication request..</param>
        /// <param name="project">project.</param>
        /// <param name="publicationServiceRorId">Identifier for the publication service used for this request..</param>
        /// <param name="creator">creator.</param>
        /// <param name="dateCreated">The date and time when the request was created..</param>
        /// <param name="message">Optional message associated with the publication request..</param>
        /// <param name="resources">Collection of the resources involved in the publication request..</param>
        public ProjectPublicationRequestDto(Guid id = default(Guid), ProjectMinimalDto project = default(ProjectMinimalDto), string publicationServiceRorId = default(string), UserMinimalDto creator = default(UserMinimalDto), DateTime dateCreated = default(DateTime), string message = default(string), List<ResourceMinimalDto> resources = default(List<ResourceMinimalDto>))
        {
            this.Id = id;
            this.Project = project;
            this.PublicationServiceRorId = publicationServiceRorId;
            this.Creator = creator;
            this.DateCreated = dateCreated;
            this.Message = message;
            this.Resources = resources;
        }

        /// <summary>
        /// Unique identifier for the project publication request.
        /// </summary>
        /// <value>Unique identifier for the project publication request.</value>
        [DataMember(Name = "id", EmitDefaultValue = false)]
        public Guid Id { get; set; }

        /// <summary>
        /// Gets or Sets Project
        /// </summary>
        [DataMember(Name = "project", EmitDefaultValue = false)]
        public ProjectMinimalDto Project { get; set; }

        /// <summary>
        /// Identifier for the publication service used for this request.
        /// </summary>
        /// <value>Identifier for the publication service used for this request.</value>
        [DataMember(Name = "publicationServiceRorId", EmitDefaultValue = false)]
        public string PublicationServiceRorId { get; set; }

        /// <summary>
        /// Gets or Sets Creator
        /// </summary>
        [DataMember(Name = "creator", EmitDefaultValue = false)]
        public UserMinimalDto Creator { get; set; }

        /// <summary>
        /// The date and time when the request was created.
        /// </summary>
        /// <value>The date and time when the request was created.</value>
        [DataMember(Name = "dateCreated", EmitDefaultValue = false)]
        public DateTime DateCreated { get; set; }

        /// <summary>
        /// Optional message associated with the publication request.
        /// </summary>
        /// <value>Optional message associated with the publication request.</value>
        [DataMember(Name = "message", EmitDefaultValue = true)]
        public string Message { get; set; }

        /// <summary>
        /// Collection of the resources involved in the publication request.
        /// </summary>
        /// <value>Collection of the resources involved in the publication request.</value>
        [DataMember(Name = "resources", EmitDefaultValue = false)]
        public List<ResourceMinimalDto> Resources { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class ProjectPublicationRequestDto {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  Project: ").Append(Project).Append("\n");
            sb.Append("  PublicationServiceRorId: ").Append(PublicationServiceRorId).Append("\n");
            sb.Append("  Creator: ").Append(Creator).Append("\n");
            sb.Append("  DateCreated: ").Append(DateCreated).Append("\n");
            sb.Append("  Message: ").Append(Message).Append("\n");
            sb.Append("  Resources: ").Append(Resources).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
