/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Data transfer object (DTO) representing the update of provenance  Inherits from the base class Coscine.Api.Core.Shared.DataTransferObjects.ParameterObjects.ProvenanceParametersDto.
    /// </summary>
    [DataContract(Name = "ProvenanceForUpdateDto")]
    public partial class ProvenanceForUpdateDto : IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ProvenanceForUpdateDto" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ProvenanceForUpdateDto() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ProvenanceForUpdateDto" /> class.
        /// </summary>
        /// <param name="wasRevisionOf">Gets or sets the adapted versions from the specific metadata tree..</param>
        /// <param name="variants">Gets or sets the variants of the specific metadata tree..</param>
        /// <param name="wasInvalidatedBy">Information if the specific metadata tree was invalidated by something..</param>
        /// <param name="similarityToLastVersion">The similarity to the last version..</param>
        /// <param name="metadataExtractorVersion">Gets or initializes the version of the metadata extractor..</param>
        /// <param name="hashParameters">hashParameters.</param>
        /// <param name="id">Gets or sets the id of the specific metadata tree. (required).</param>
        public ProvenanceForUpdateDto(List<string> wasRevisionOf = default(List<string>), List<VariantDto> variants = default(List<VariantDto>), string wasInvalidatedBy = default(string), double? similarityToLastVersion = default(double?), string metadataExtractorVersion = default(string), HashParametersDto hashParameters = default(HashParametersDto), string id = default(string))
        {
            // to ensure "id" is required (not null)
            if (id == null)
            {
                throw new ArgumentNullException("id is a required property for ProvenanceForUpdateDto and cannot be null");
            }
            this.Id = id;
            this.WasRevisionOf = wasRevisionOf;
            this.Variants = variants;
            this.WasInvalidatedBy = wasInvalidatedBy;
            this.SimilarityToLastVersion = similarityToLastVersion;
            this.MetadataExtractorVersion = metadataExtractorVersion;
            this.HashParameters = hashParameters;
        }

        /// <summary>
        /// Gets or sets the adapted versions from the specific metadata tree.
        /// </summary>
        /// <value>Gets or sets the adapted versions from the specific metadata tree.</value>
        [DataMember(Name = "wasRevisionOf", EmitDefaultValue = false)]
        public List<string> WasRevisionOf { get; set; }

        /// <summary>
        /// Gets or sets the variants of the specific metadata tree.
        /// </summary>
        /// <value>Gets or sets the variants of the specific metadata tree.</value>
        [DataMember(Name = "variants", EmitDefaultValue = false)]
        public List<VariantDto> Variants { get; set; }

        /// <summary>
        /// Information if the specific metadata tree was invalidated by something.
        /// </summary>
        /// <value>Information if the specific metadata tree was invalidated by something.</value>
        [DataMember(Name = "wasInvalidatedBy", EmitDefaultValue = true)]
        public string WasInvalidatedBy { get; set; }

        /// <summary>
        /// The similarity to the last version.
        /// </summary>
        /// <value>The similarity to the last version.</value>
        [DataMember(Name = "similarityToLastVersion", EmitDefaultValue = true)]
        public double? SimilarityToLastVersion { get; set; }

        /// <summary>
        /// Gets or initializes the version of the metadata extractor.
        /// </summary>
        /// <value>Gets or initializes the version of the metadata extractor.</value>
        [DataMember(Name = "metadataExtractorVersion", EmitDefaultValue = true)]
        public string MetadataExtractorVersion { get; set; }

        /// <summary>
        /// Gets or Sets HashParameters
        /// </summary>
        [DataMember(Name = "hashParameters", EmitDefaultValue = false)]
        public HashParametersDto HashParameters { get; set; }

        /// <summary>
        /// Gets or sets the id of the specific metadata tree.
        /// </summary>
        /// <value>Gets or sets the id of the specific metadata tree.</value>
        [DataMember(Name = "id", IsRequired = true, EmitDefaultValue = true)]
        public string Id { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class ProvenanceForUpdateDto {\n");
            sb.Append("  WasRevisionOf: ").Append(WasRevisionOf).Append("\n");
            sb.Append("  Variants: ").Append(Variants).Append("\n");
            sb.Append("  WasInvalidatedBy: ").Append(WasInvalidatedBy).Append("\n");
            sb.Append("  SimilarityToLastVersion: ").Append(SimilarityToLastVersion).Append("\n");
            sb.Append("  MetadataExtractorVersion: ").Append(MetadataExtractorVersion).Append("\n");
            sb.Append("  HashParameters: ").Append(HashParameters).Append("\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
