/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Represents the data transfer object (DTO) used for manipulating RDF definitions.
    /// </summary>
    [DataContract(Name = "RdfDefinitionForManipulationDto")]
    public partial class RdfDefinitionForManipulationDto : IValidatableObject
    {

        /// <summary>
        /// Gets or Sets Type
        /// </summary>
        [DataMember(Name = "type", IsRequired = true, EmitDefaultValue = true)]
        public RdfFormat Type { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="RdfDefinitionForManipulationDto" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected RdfDefinitionForManipulationDto() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="RdfDefinitionForManipulationDto" /> class.
        /// </summary>
        /// <param name="content">The content of the RDF definition. (required).</param>
        /// <param name="type">type (required).</param>
        public RdfDefinitionForManipulationDto(string content = default(string), RdfFormat type = default(RdfFormat))
        {
            // to ensure "content" is required (not null)
            if (content == null)
            {
                throw new ArgumentNullException("content is a required property for RdfDefinitionForManipulationDto and cannot be null");
            }
            this.Content = content;
            this.Type = type;
        }

        /// <summary>
        /// The content of the RDF definition.
        /// </summary>
        /// <value>The content of the RDF definition.</value>
        [DataMember(Name = "content", IsRequired = true, EmitDefaultValue = true)]
        public string Content { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class RdfDefinitionForManipulationDto {\n");
            sb.Append("  Content: ").Append(Content).Append("\n");
            sb.Append("  Type: ").Append(Type).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // Content (string) minLength
            if (this.Content != null && this.Content.Length < 1)
            {
                yield return new ValidationResult("Invalid value for Content, length must be greater than 1.", new [] { "Content" });
            }

            yield break;
        }
    }

}
