/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Represents the content page details for a resource.
    /// </summary>
    [DataContract(Name = "ResourceContentPageDto")]
    public partial class ResourceContentPageDto : IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ResourceContentPageDto" /> class.
        /// </summary>
        /// <param name="readOnly">Indicates whether the resource is read-only..</param>
        /// <param name="metadataView">metadataView.</param>
        /// <param name="entriesView">entriesView.</param>
        public ResourceContentPageDto(bool readOnly = default(bool), ResourceContentPageMetadataViewDto metadataView = default(ResourceContentPageMetadataViewDto), ResourceContentPageEntriesViewDto entriesView = default(ResourceContentPageEntriesViewDto))
        {
            this.ReadOnly = readOnly;
            this.MetadataView = metadataView;
            this.EntriesView = entriesView;
        }

        /// <summary>
        /// Indicates whether the resource is read-only.
        /// </summary>
        /// <value>Indicates whether the resource is read-only.</value>
        [DataMember(Name = "readOnly", EmitDefaultValue = true)]
        public bool ReadOnly { get; set; }

        /// <summary>
        /// Gets or Sets MetadataView
        /// </summary>
        [DataMember(Name = "metadataView", EmitDefaultValue = false)]
        public ResourceContentPageMetadataViewDto MetadataView { get; set; }

        /// <summary>
        /// Gets or Sets EntriesView
        /// </summary>
        [DataMember(Name = "entriesView", EmitDefaultValue = false)]
        public ResourceContentPageEntriesViewDto EntriesView { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class ResourceContentPageDto {\n");
            sb.Append("  ReadOnly: ").Append(ReadOnly).Append("\n");
            sb.Append("  MetadataView: ").Append(MetadataView).Append("\n");
            sb.Append("  EntriesView: ").Append(EntriesView).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
