/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Represents the structure of resource type-specific components for steps in the resource creation page.
    /// </summary>
    [DataContract(Name = "ResourceCreationPageDto")]
    public partial class ResourceCreationPageDto : IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ResourceCreationPageDto" /> class.
        /// </summary>
        /// <param name="components">List of Lists containing all the resource type specific components for the steps in the resource creation page..</param>
        public ResourceCreationPageDto(List<List<string>> components = default(List<List<string>>))
        {
            this.Components = components;
        }

        /// <summary>
        /// List of Lists containing all the resource type specific components for the steps in the resource creation page.
        /// </summary>
        /// <value>List of Lists containing all the resource type specific components for the steps in the resource creation page.</value>
        [DataMember(Name = "components", EmitDefaultValue = false)]
        public List<List<string>> Components { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class ResourceCreationPageDto {\n");
            sb.Append("  Components: ").Append(Components).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
