/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Represents the data transfer object (DTO) used for creating a resource.  Inherits properties from Coscine.Api.Core.Shared.DataTransferObjects.ParameterObjects.ResourceForManipulationDto.
    /// </summary>
    [DataContract(Name = "ResourceForCreationDto")]
    public partial class ResourceForCreationDto : IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ResourceForCreationDto" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ResourceForCreationDto() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ResourceForCreationDto" /> class.
        /// </summary>
        /// <param name="name">The name of the resource. (required).</param>
        /// <param name="displayName">The display name of the resource..</param>
        /// <param name="description">The description of the resource. (required).</param>
        /// <param name="keywords">The keywords associated with the resource..</param>
        /// <param name="fixedValues">Fixed values associated with the resource..</param>
        /// <param name="license">license.</param>
        /// <param name="usageRights">The usage rights description of the resource..</param>
        /// <param name="metadataLocalCopy">If a local copy for the metadata should be created..</param>
        /// <param name="visibility">visibility (required).</param>
        /// <param name="disciplines">The disciplines associated with the resource. (required).</param>
        /// <param name="resourceTypeId">The identifier of the resource type associated with the resource. (required).</param>
        /// <param name="applicationProfile">applicationProfile (required).</param>
        /// <param name="resourceTypeOptions">resourceTypeOptions (required).</param>
        public ResourceForCreationDto(string name = default(string), string displayName = default(string), string description = default(string), List<string> keywords = default(List<string>), Dictionary<string, Dictionary<string, List<FixedValueForResourceManipulationDto>>> fixedValues = default(Dictionary<string, Dictionary<string, List<FixedValueForResourceManipulationDto>>>), LicenseForResourceManipulationDto license = default(LicenseForResourceManipulationDto), string usageRights = default(string), bool? metadataLocalCopy = default(bool?), VisibilityForResourceManipulationDto visibility = default(VisibilityForResourceManipulationDto), List<DisciplineForResourceManipulationDto> disciplines = default(List<DisciplineForResourceManipulationDto>), Guid resourceTypeId = default(Guid), ApplicationProfileForResourceCreationDto applicationProfile = default(ApplicationProfileForResourceCreationDto), ResourceTypeOptionsForCreationDto resourceTypeOptions = default(ResourceTypeOptionsForCreationDto))
        {
            // to ensure "name" is required (not null)
            if (name == null)
            {
                throw new ArgumentNullException("name is a required property for ResourceForCreationDto and cannot be null");
            }
            this.Name = name;
            // to ensure "description" is required (not null)
            if (description == null)
            {
                throw new ArgumentNullException("description is a required property for ResourceForCreationDto and cannot be null");
            }
            this.Description = description;
            // to ensure "visibility" is required (not null)
            if (visibility == null)
            {
                throw new ArgumentNullException("visibility is a required property for ResourceForCreationDto and cannot be null");
            }
            this.Visibility = visibility;
            // to ensure "disciplines" is required (not null)
            if (disciplines == null)
            {
                throw new ArgumentNullException("disciplines is a required property for ResourceForCreationDto and cannot be null");
            }
            this.Disciplines = disciplines;
            this.ResourceTypeId = resourceTypeId;
            // to ensure "applicationProfile" is required (not null)
            if (applicationProfile == null)
            {
                throw new ArgumentNullException("applicationProfile is a required property for ResourceForCreationDto and cannot be null");
            }
            this.ApplicationProfile = applicationProfile;
            // to ensure "resourceTypeOptions" is required (not null)
            if (resourceTypeOptions == null)
            {
                throw new ArgumentNullException("resourceTypeOptions is a required property for ResourceForCreationDto and cannot be null");
            }
            this.ResourceTypeOptions = resourceTypeOptions;
            this.DisplayName = displayName;
            this.Keywords = keywords;
            this.FixedValues = fixedValues;
            this.License = license;
            this.UsageRights = usageRights;
            this.MetadataLocalCopy = metadataLocalCopy;
        }

        /// <summary>
        /// The name of the resource.
        /// </summary>
        /// <value>The name of the resource.</value>
        [DataMember(Name = "name", IsRequired = true, EmitDefaultValue = true)]
        public string Name { get; set; }

        /// <summary>
        /// The display name of the resource.
        /// </summary>
        /// <value>The display name of the resource.</value>
        [DataMember(Name = "displayName", EmitDefaultValue = true)]
        public string DisplayName { get; set; }

        /// <summary>
        /// The description of the resource.
        /// </summary>
        /// <value>The description of the resource.</value>
        [DataMember(Name = "description", IsRequired = true, EmitDefaultValue = true)]
        public string Description { get; set; }

        /// <summary>
        /// The keywords associated with the resource.
        /// </summary>
        /// <value>The keywords associated with the resource.</value>
        [DataMember(Name = "keywords", EmitDefaultValue = true)]
        public List<string> Keywords { get; set; }

        /// <summary>
        /// Fixed values associated with the resource.
        /// </summary>
        /// <value>Fixed values associated with the resource.</value>
        [DataMember(Name = "fixedValues", EmitDefaultValue = true)]
        public Dictionary<string, Dictionary<string, List<FixedValueForResourceManipulationDto>>> FixedValues { get; set; }

        /// <summary>
        /// Gets or Sets License
        /// </summary>
        [DataMember(Name = "license", EmitDefaultValue = false)]
        public LicenseForResourceManipulationDto License { get; set; }

        /// <summary>
        /// The usage rights description of the resource.
        /// </summary>
        /// <value>The usage rights description of the resource.</value>
        [DataMember(Name = "usageRights", EmitDefaultValue = true)]
        public string UsageRights { get; set; }

        /// <summary>
        /// If a local copy for the metadata should be created.
        /// </summary>
        /// <value>If a local copy for the metadata should be created.</value>
        [DataMember(Name = "metadataLocalCopy", EmitDefaultValue = true)]
        public bool? MetadataLocalCopy { get; set; }

        /// <summary>
        /// Gets or Sets Visibility
        /// </summary>
        [DataMember(Name = "visibility", IsRequired = true, EmitDefaultValue = true)]
        public VisibilityForResourceManipulationDto Visibility { get; set; }

        /// <summary>
        /// The disciplines associated with the resource.
        /// </summary>
        /// <value>The disciplines associated with the resource.</value>
        [DataMember(Name = "disciplines", IsRequired = true, EmitDefaultValue = true)]
        public List<DisciplineForResourceManipulationDto> Disciplines { get; set; }

        /// <summary>
        /// The identifier of the resource type associated with the resource.
        /// </summary>
        /// <value>The identifier of the resource type associated with the resource.</value>
        [DataMember(Name = "resourceTypeId", IsRequired = true, EmitDefaultValue = true)]
        public Guid ResourceTypeId { get; set; }

        /// <summary>
        /// Gets or Sets ApplicationProfile
        /// </summary>
        [DataMember(Name = "applicationProfile", IsRequired = true, EmitDefaultValue = true)]
        public ApplicationProfileForResourceCreationDto ApplicationProfile { get; set; }

        /// <summary>
        /// Gets or Sets ResourceTypeOptions
        /// </summary>
        [DataMember(Name = "resourceTypeOptions", IsRequired = true, EmitDefaultValue = true)]
        public ResourceTypeOptionsForCreationDto ResourceTypeOptions { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class ResourceForCreationDto {\n");
            sb.Append("  Name: ").Append(Name).Append("\n");
            sb.Append("  DisplayName: ").Append(DisplayName).Append("\n");
            sb.Append("  Description: ").Append(Description).Append("\n");
            sb.Append("  Keywords: ").Append(Keywords).Append("\n");
            sb.Append("  FixedValues: ").Append(FixedValues).Append("\n");
            sb.Append("  License: ").Append(License).Append("\n");
            sb.Append("  UsageRights: ").Append(UsageRights).Append("\n");
            sb.Append("  MetadataLocalCopy: ").Append(MetadataLocalCopy).Append("\n");
            sb.Append("  Visibility: ").Append(Visibility).Append("\n");
            sb.Append("  Disciplines: ").Append(Disciplines).Append("\n");
            sb.Append("  ResourceTypeId: ").Append(ResourceTypeId).Append("\n");
            sb.Append("  ApplicationProfile: ").Append(ApplicationProfile).Append("\n");
            sb.Append("  ResourceTypeOptions: ").Append(ResourceTypeOptions).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // Name (string) maxLength
            if (this.Name != null && this.Name.Length > 200)
            {
                yield return new ValidationResult("Invalid value for Name, length must be less than 200.", new [] { "Name" });
            }

            // Name (string) minLength
            if (this.Name != null && this.Name.Length < 1)
            {
                yield return new ValidationResult("Invalid value for Name, length must be greater than 1.", new [] { "Name" });
            }

            // DisplayName (string) maxLength
            if (this.DisplayName != null && this.DisplayName.Length > 25)
            {
                yield return new ValidationResult("Invalid value for DisplayName, length must be less than 25.", new [] { "DisplayName" });
            }

            // Description (string) maxLength
            if (this.Description != null && this.Description.Length > 10000)
            {
                yield return new ValidationResult("Invalid value for Description, length must be less than 10000.", new [] { "Description" });
            }

            // Description (string) minLength
            if (this.Description != null && this.Description.Length < 1)
            {
                yield return new ValidationResult("Invalid value for Description, length must be greater than 1.", new [] { "Description" });
            }

            // UsageRights (string) maxLength
            if (this.UsageRights != null && this.UsageRights.Length > 200)
            {
                yield return new ValidationResult("Invalid value for UsageRights, length must be less than 200.", new [] { "UsageRights" });
            }

            yield break;
        }
    }

}
