/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Represents a Data Transfer Object (DTO) containing quota information for a resource.
    /// </summary>
    [DataContract(Name = "ResourceQuotaDto")]
    public partial class ResourceQuotaDto : IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ResourceQuotaDto" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ResourceQuotaDto() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ResourceQuotaDto" /> class.
        /// </summary>
        /// <param name="resource">resource (required).</param>
        /// <param name="usedPercentage">The percentage of quota used by the resource..</param>
        /// <param name="used">used.</param>
        /// <param name="reserved">reserved.</param>
        public ResourceQuotaDto(ResourceMinimalDto resource = default(ResourceMinimalDto), float? usedPercentage = default(float?), QuotaDto used = default(QuotaDto), QuotaDto reserved = default(QuotaDto))
        {
            // to ensure "resource" is required (not null)
            if (resource == null)
            {
                throw new ArgumentNullException("resource is a required property for ResourceQuotaDto and cannot be null");
            }
            this.Resource = resource;
            this.UsedPercentage = usedPercentage;
            this.Used = used;
            this.Reserved = reserved;
        }

        /// <summary>
        /// Gets or Sets Resource
        /// </summary>
        [DataMember(Name = "resource", IsRequired = true, EmitDefaultValue = true)]
        public ResourceMinimalDto Resource { get; set; }

        /// <summary>
        /// The percentage of quota used by the resource.
        /// </summary>
        /// <value>The percentage of quota used by the resource.</value>
        [DataMember(Name = "usedPercentage", EmitDefaultValue = true)]
        public float? UsedPercentage { get; set; }

        /// <summary>
        /// Gets or Sets Used
        /// </summary>
        [DataMember(Name = "used", EmitDefaultValue = false)]
        public QuotaDto Used { get; set; }

        /// <summary>
        /// Gets or Sets Reserved
        /// </summary>
        [DataMember(Name = "reserved", EmitDefaultValue = false)]
        public QuotaDto Reserved { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class ResourceQuotaDto {\n");
            sb.Append("  Resource: ").Append(Resource).Append("\n");
            sb.Append("  UsedPercentage: ").Append(UsedPercentage).Append("\n");
            sb.Append("  Used: ").Append(Used).Append("\n");
            sb.Append("  Reserved: ").Append(Reserved).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
