/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Represents a Data Transfer Object (DTO) for user email information.
    /// </summary>
    [DataContract(Name = "UserEmailDto")]
    public partial class UserEmailDto : IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="UserEmailDto" /> class.
        /// </summary>
        /// <param name="email">The email address of the user..</param>
        /// <param name="isConfirmed">Indicates whether the email address is confirmed..</param>
        /// <param name="isPrimary">Indicates whether the email address is the primary one for the user..</param>
        public UserEmailDto(string email = default(string), bool isConfirmed = default(bool), bool isPrimary = default(bool))
        {
            this.Email = email;
            this.IsConfirmed = isConfirmed;
            this.IsPrimary = isPrimary;
        }

        /// <summary>
        /// The email address of the user.
        /// </summary>
        /// <value>The email address of the user.</value>
        [DataMember(Name = "email", EmitDefaultValue = true)]
        public string Email { get; set; }

        /// <summary>
        /// Indicates whether the email address is confirmed.
        /// </summary>
        /// <value>Indicates whether the email address is confirmed.</value>
        [DataMember(Name = "isConfirmed", EmitDefaultValue = true)]
        public bool IsConfirmed { get; set; }

        /// <summary>
        /// Indicates whether the email address is the primary one for the user.
        /// </summary>
        /// <value>Indicates whether the email address is the primary one for the user.</value>
        [DataMember(Name = "isPrimary", EmitDefaultValue = true)]
        public bool IsPrimary { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class UserEmailDto {\n");
            sb.Append("  Email: ").Append(Email).Append("\n");
            sb.Append("  IsConfirmed: ").Append(IsConfirmed).Append("\n");
            sb.Append("  IsPrimary: ").Append(IsPrimary).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
