/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Represents the variants of this specific metadata tree.
    /// </summary>
    [DataContract(Name = "VariantDto")]
    public partial class VariantDto : IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="VariantDto" /> class.
        /// </summary>
        /// <param name="graphName">Name of the graph..</param>
        /// <param name="similarity">Similarity value 0-1.</param>
        public VariantDto(string graphName = default(string), double similarity = default(double))
        {
            this.GraphName = graphName;
            this.Similarity = similarity;
        }

        /// <summary>
        /// Name of the graph.
        /// </summary>
        /// <value>Name of the graph.</value>
        [DataMember(Name = "graphName", EmitDefaultValue = false)]
        public string GraphName { get; set; }

        /// <summary>
        /// Similarity value 0-1
        /// </summary>
        /// <value>Similarity value 0-1</value>
        [DataMember(Name = "similarity", EmitDefaultValue = false)]
        public double Similarity { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class VariantDto {\n");
            sb.Append("  GraphName: ").Append(GraphName).Append("\n");
            sb.Append("  Similarity: ").Append(Similarity).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
